# -*- coding: utf-8 -*-

"""
    Script that saves in DB the L2A products.

    Usage:
    $ cd GeoInt_SIDT
    $ python manage.py populate_products_l2a
"""


from django.core.management.base import BaseCommand, CommandError
from catalog.models import Product_l1c, Product_l2a
import os, sys, paramiko

SSH_ADDRESS  = "192.168.1.59"
SSH_USERNAME = "geoint"
SSH_COMMAND  = "cd NAS/sentinelImages/L2A/; pwd"

ssh = paramiko.SSHClient()
ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())


class Command(BaseCommand):

    def handle(self, *args, **options):
        ssh_stdin = ssh_stdout = ssh_stderr = None

        try:
            ssh.connect(SSH_ADDRESS, username=SSH_USERNAME)
            ssh_stdin, ssh_stdout, ssh_stderr = ssh.exec_command(SSH_COMMAND)
            path = ssh_stdout.read().replace("\n", '')

            sftp = ssh.open_sftp()  ## Creates SFTPClient() object
            sftp.chdir(path)
            file_list = sftp.listdir()
            file_list.sort()

            for file in file_list:
                file_name = file.replace(".zip", '')

                try:
                    PRODUCT_EXISTS = Product_l2a.objects.filter(identifier=file_name).exists()
                    
                    if not PRODUCT_EXISTS:
                        file_path = path + "/" + file

                        prod_l1c = Product_l1c.objects.filter(identifier=file_name.replace("L2A", "L1C"))[0]

                        product_l2a = Product_l2a(
                            prod_l1c   = prod_l1c,
                            identifier = file_name,
                            file_path  = file_path
                        )

                        product_l2a.save()
                        print "NEW product: " + file_name

                    # else:
                    #     print "Product " + file_name + " is ALREADY in DB."

                except:
                    print "Error con archivo " + file
        
        except Exception as e:
            sys.stderr.write("SSH connection error: {0}".format(e))

        if ssh_stdout:
            sys.stdout.write(ssh_stdout.read())
        if ssh_stderr:
            sys.stderr.write(ssh_stderr.read())

        sftp.close()
        ssh.close()
